// another fine solution by misof
#include <cstdio>
#include <queue>
using namespace std;

#define MAX 1234567

int N, M, K;
int E[MAX][3];
int D[MAX];
int damaged[MAX];
int components;
int answer[MAX];

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  for (int m=1; m<=M; ++m) { scanf("%d%d",&E[m][0],&E[m][1]); E[m][2]=M+1; }
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) { scanf("%d",&D[k]); E[D[k]][2]=k; }
  for (int k=0; k<=K; ++k) {
    int G[N+1][N+1];
    for (int a=1; a<=N; ++a) for (int b=1; b<=N; ++b) G[a][b]=0;
    for (int a=1; a<=N; ++a) G[a][a]=1;
    for (int m=1; m<=M; ++m) if (E[m][2]>k) G[E[m][0]][E[m][1]] = G[E[m][1]][E[m][0]] = 1;
    int components = 0;
    int uz[N+1];
    for (int a=1; a<=N; ++a) uz[a]=0;
    for (int a=1; a<=N; ++a) if (!uz[a]) {
      ++components;
      queue<int> Q;
      Q.push(a);
      uz[a] = 1;
      while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        for (int b=1; b<=N; ++b) if (G[kde][b] && !uz[b]) { uz[b]=1; Q.push(b); }
      }
    }
    printf("%d\n",components-1);
  }
}
